/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;

import java.util.Objects;

/**
 * Coverage
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class Coverage {
  @SerializedName("type")
  private String type = null;

  @SerializedName("class")
  private String propertyClass = null;

  @SerializedName("category")
  private String category = null;

  @SerializedName("label")
  private String label = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("limits")
  private Limits limits = null;

  @SerializedName("exclusions")
  private Exclusions exclusions = null;

  @SerializedName("benefits")
  private Benefits benefits = null;

  public Coverage type(String type) {
    this.type = type;
    return this;
  }

   /**
   * Type of coverage.
   * @return type
  **/
  @ApiModelProperty(example = "SERVICE", value = "Type of coverage.")
  public String getType() {
    return type;
  }

  public void setType(String type) {
    this.type = type;
  }

  public Coverage propertyClass(String propertyClass) {
    this.propertyClass = propertyClass;
    return this;
  }

   /**
   * Class of coverage.
   * @return propertyClass
  **/
  @ApiModelProperty(example = "ACCIDENT_01", value = "Class of coverage.")
  public String getPropertyClass() {
    return propertyClass;
  }

  public void setPropertyClass(String propertyClass) {
    this.propertyClass = propertyClass;
  }

  public Coverage category(String category) {
    this.category = category;
    return this;
  }

   /**
   * Coverage category.
   * @return category
  **/
  @ApiModelProperty(example = "plumbing", value = "Coverage category.")
  public String getCategory() {
    return category;
  }

  public void setCategory(String category) {
    this.category = category;
  }

  public Coverage label(String label) {
    this.label = label;
    return this;
  }

   /**
   * Label.
   * @return label
  **/
  @ApiModelProperty(example = "Electronic Assistance.", required = true, value = "Label.")
  public String getLabel() {
    return label;
  }

  public void setLabel(String label) {
    this.label = label;
  }

  public Coverage description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description.
   * @return description
  **/
  @ApiModelProperty(example = "Customer assistance for electronics.", value = "Description.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public Coverage limits(Limits limits) {
    this.limits = limits;
    return this;
  }

   /**
   * Get limits
   * @return limits
  **/
  @ApiModelProperty(value = "")
  public Limits getLimits() {
    return limits;
  }

  public void setLimits(Limits limits) {
    this.limits = limits;
  }

  public Coverage exclusions(Exclusions exclusions) {
    this.exclusions = exclusions;
    return this;
  }

   /**
   * Get exclusions
   * @return exclusions
  **/
  @ApiModelProperty(value = "")
  public Exclusions getExclusions() {
    return exclusions;
  }

  public void setExclusions(Exclusions exclusions) {
    this.exclusions = exclusions;
  }

  public Coverage benefits(Benefits benefits) {
    this.benefits = benefits;
    return this;
  }

   /**
   * Get benefits
   * @return benefits
  **/
  @ApiModelProperty(value = "")
  public Benefits getBenefits() {
    return benefits;
  }

  public void setBenefits(Benefits benefits) {
    this.benefits = benefits;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Coverage coverage = (Coverage) o;
    return Objects.equals(this.type, coverage.type) &&
        Objects.equals(this.propertyClass, coverage.propertyClass) &&
        Objects.equals(this.category, coverage.category) &&
        Objects.equals(this.label, coverage.label) &&
        Objects.equals(this.description, coverage.description) &&
        Objects.equals(this.limits, coverage.limits) &&
        Objects.equals(this.exclusions, coverage.exclusions) &&
        Objects.equals(this.benefits, coverage.benefits);
  }

  @Override
  public int hashCode() {
    return Objects.hash(type, propertyClass, category, label, description, limits, exclusions, benefits);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Coverage {\n");
    
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    propertyClass: ").append(toIndentedString(propertyClass)).append("\n");
    sb.append("    category: ").append(toIndentedString(category)).append("\n");
    sb.append("    label: ").append(toIndentedString(label)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    limits: ").append(toIndentedString(limits)).append("\n");
    sb.append("    exclusions: ").append(toIndentedString(exclusions)).append("\n");
    sb.append("    benefits: ").append(toIndentedString(benefits)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

